package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.TSSDTaskLog;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class TSSDTaskLogSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<TSSDTaskLog> selectCond;
	private JSONObject customsearchval;
	public TSSDTaskLogSearchFilter(){
		this.page =new Page<TSSDTaskLog>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<TSSDTaskLog>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_tssdtaskid_eq;

	public void setN_tssdtaskid_eq(String n_tssdtaskid_eq) {
        this.n_tssdtaskid_eq = n_tssdtaskid_eq;
        if(!StringUtils.isEmpty(this.n_tssdtaskid_eq)){
            this.selectCond.eq("tssdtaskid", n_tssdtaskid_eq);
        }
    }
	private String n_tssdtasklogname_like;

	public void setN_tssdtasklogname_like(String n_tssdtasklogname_like) {
        this.n_tssdtasklogname_like = n_tssdtasklogname_like;
        if(!StringUtils.isEmpty(this.n_tssdtasklogname_like)){
            this.selectCond.like("tssdtasklogname", n_tssdtasklogname_like);
        }
    }
	private String n_tssdtaskname_eq;

	public void setN_tssdtaskname_eq(String n_tssdtaskname_eq) {
        this.n_tssdtaskname_eq = n_tssdtaskname_eq;
        if(!StringUtils.isEmpty(this.n_tssdtaskname_eq)){
            this.selectCond.eq("tssdtaskname", n_tssdtaskname_eq);
        }
    }
	private String n_tssdtaskname_like;

	public void setN_tssdtaskname_like(String n_tssdtaskname_like) {
        this.n_tssdtaskname_like = n_tssdtaskname_like;
        if(!StringUtils.isEmpty(this.n_tssdtaskname_like)){
            this.selectCond.like("tssdtaskname", n_tssdtaskname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_TSSDTASKLOG_TSSDTASK_TSSDTASKID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_tssdtaskid_eq("NA");
			}
			else{
				this.setN_tssdtaskid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("tssdtasklogname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}